diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/config.cc ns-3.31/src/core/model/config.cc
--- ns-3.30.1/src/core/model/config.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/config.cc	2020-06-27 17:38:30.000000000 -0700
@@ -48,8 +48,8 @@
                                 const std::vector<std::string> &contexts,
                                 std::string path)
   : m_objects (objects),
-    m_contexts (contexts),
-    m_path (path)
+  m_contexts (contexts),
+  m_path (path)
 {
   NS_LOG_FUNCTION (this << &objects << &contexts << path);
 }
@@ -97,33 +97,65 @@
   for (Iterator tmp = Begin (); tmp != End (); ++tmp)
     {
       Ptr<Object> object = *tmp;
+      // Let ObjectBase::SetAttribute raise any errors
       object->SetAttribute (name, value);
     }
 }
-void 
+bool
+MatchContainer::SetFailSafe (std::string name, const AttributeValue &value)
+{
+  NS_LOG_FUNCTION (this << name << &value);
+  bool ok = false;
+  for (Iterator tmp = Begin (); tmp != End (); ++tmp)
+    {
+      Ptr<Object> object = *tmp;
+      ok |= object->SetAttributeFailSafe (name, value);
+    }
+  return ok;
+}
+void
 MatchContainer::Connect (std::string name, const CallbackBase &cb)
 {
+  if (!ConnectFailSafe (name, cb))
+    {
+      NS_FATAL_ERROR ("Cound not connect callback to " << name);
+    }
+}
+bool
+MatchContainer::ConnectFailSafe (std::string name, const CallbackBase &cb)
+{
   NS_LOG_FUNCTION (this << name << &cb);
   NS_ASSERT (m_objects.size () == m_contexts.size ());
+  bool ok = false;
   for (uint32_t i = 0; i < m_objects.size (); ++i)
     {
       Ptr<Object> object = m_objects[i];
       std::string ctx = m_contexts[i] + name;
-      object->TraceConnect (name, ctx, cb);
+      ok |= object->TraceConnect (name, ctx, cb);
     }
+  return ok;
 }
-void 
+void
 MatchContainer::ConnectWithoutContext (std::string name, const CallbackBase &cb)
 {
+  if (!ConnectWithoutContextFailSafe (name, cb))
+    {
+      NS_FATAL_ERROR ("Could not connect callback to " << name);
+    }
+}
+bool
+MatchContainer::ConnectWithoutContextFailSafe (std::string name, const CallbackBase &cb)
+{
   NS_LOG_FUNCTION (this << name << &cb);
-
+  bool ok = false;
   for (Iterator tmp = Begin (); tmp != End (); ++tmp)
     {
       Ptr<Object> object = *tmp;
-      object->TraceConnectWithoutContext (name, cb);
+      ok |= object->TraceConnectWithoutContext (name, cb);
     }
+  return ok;
 }
-void 
+void
 MatchContainer::Disconnect (std::string name, const CallbackBase &cb)
 {
   NS_LOG_FUNCTION (this << name << &cb);
@@ -135,7 +167,7 @@
       object->TraceDisconnect (name, ctx, cb);
     }
 }
-void 
+void
 MatchContainer::DisconnectWithoutContext (std::string name, const CallbackBase &cb)
 {
   NS_LOG_FUNCTION (this << name << &cb);
@@ -167,6 +199,7 @@
    * \returns \c true if the index matches the Config Path.
    */
   bool Matches (std::size_t i) const;
+
 private:
   /**
    * Convert a string to an \c uint32_t.
@@ -193,61 +226,61 @@
   NS_LOG_FUNCTION (this << i);
   if (m_element == "*")
     {
-      NS_LOG_DEBUG ("Array "<<i<<" matches *");
+      NS_LOG_DEBUG ("Array " << i << " matches *");
       return true;
     }
   std::string::size_type tmp;
   tmp = m_element.find ("|");
   if (tmp != std::string::npos)
     {
-      std::string left = m_element.substr (0, tmp-0);
-      std::string right = m_element.substr (tmp+1, m_element.size () - (tmp + 1));
+      std::string left = m_element.substr (0, tmp - 0);
+      std::string right = m_element.substr (tmp + 1, m_element.size () - (tmp + 1));
       ArrayMatcher matcher = ArrayMatcher (left);
       if (matcher.Matches (i))
         {
-          NS_LOG_DEBUG ("Array "<<i<<" matches "<<left);
+          NS_LOG_DEBUG ("Array " << i << " matches " << left);
           return true;
         }
       matcher = ArrayMatcher (right);
       if (matcher.Matches (i))
         {
-          NS_LOG_DEBUG ("Array "<<i<<" matches "<<right);
+          NS_LOG_DEBUG ("Array " << i << " matches " << right);
           return true;
         }
-      NS_LOG_DEBUG ("Array "<<i<<" does not match "<<m_element);
+      NS_LOG_DEBUG ("Array " << i << " does not match " << m_element);
       return false;
     }
   std::string::size_type leftBracket = m_element.find ("[");
   std::string::size_type rightBracket = m_element.find ("]");
   std::string::size_type dash = m_element.find ("-");
-  if (leftBracket == 0 && rightBracket == m_element.size () - 1 &&
-      dash > leftBracket && dash < rightBracket)
+  if (leftBracket == 0 && rightBracket == m_element.size () - 1
+      && dash > leftBracket && dash < rightBracket)
     {
       std::string lowerBound = m_element.substr (leftBracket + 1, dash - (leftBracket + 1));
       std::string upperBound = m_element.substr (dash + 1, rightBracket - (dash + 1));
       uint32_t min;
       uint32_t max;
-      if (StringToUint32 (lowerBound, &min) && 
-          StringToUint32 (upperBound, &max) &&
-          i >= min && i <= max)
+      if (StringToUint32 (lowerBound, &min)
+          && StringToUint32 (upperBound, &max)
+          && i >= min && i <= max)
         {
-          NS_LOG_DEBUG ("Array "<<i<<" matches "<<m_element);
+          NS_LOG_DEBUG ("Array " << i << " matches " << m_element);
           return true;
         }
       else
         {
-          NS_LOG_DEBUG ("Array "<<i<<" does not "<<m_element);
+          NS_LOG_DEBUG ("Array " << i << " does not " << m_element);
           return false;
         }
     }
   uint32_t value;
-  if (StringToUint32 (m_element, &value) &&
-      i == value)
+  if (StringToUint32 (m_element, &value)
+      && i == value)
     {
-      NS_LOG_DEBUG ("Array "<<i<<" matches "<<m_element);
+      NS_LOG_DEBUG ("Array " << i << " matches " << m_element);
       return true;
     }
-  NS_LOG_DEBUG ("Array "<<i<<" does not match "<<m_element);
+  NS_LOG_DEBUG ("Array " << i << " does not match " << m_element);
   return false;
 }
 
@@ -285,7 +318,7 @@
    *                  in the Config path.
    */
   void Resolve (Ptr<Object> root);
-  
+
 private:
   /** Ensure the Config path starts and ends with a '/'. */
   void Canonicalize (void);
@@ -361,7 +394,7 @@
     }
 }
 
-void 
+void
 Resolver::Resolve (Ptr<Object> root)
 {
   NS_LOG_FUNCTION (this << root);
@@ -382,12 +415,12 @@
   return fullPath;
 }
 
-void 
+void
 Resolver::DoResolveOne (Ptr<Object> object)
 {
   NS_LOG_FUNCTION (this << object);
 
-  NS_LOG_DEBUG ("resolved="<<GetResolvedPath ());
+  NS_LOG_DEBUG ("resolved=" << GetResolvedPath ());
   DoOne (object, GetResolvedPath ());
 }
 
@@ -401,27 +434,27 @@
   if (next == std::string::npos)
     {
       //
-      // If root is zero, we're beginning to see if we can use the object name 
-      // service to resolve this path.  It is impossible to have a object name 
+      // If root is zero, we're beginning to see if we can use the object name
+      // service to resolve this path.  It is impossible to have a object name
       // associated with the root of the object name service since that root
       // is not an object.  This path must be referring to something in another
       // namespace and it will have been found already since the name service
       // is always consulted last.
-      // 
+      //
       if (root)
         {
           DoResolveOne (root);
         }
       return;
     }
-  std::string item = path.substr (1, next-1);
-  std::string pathLeft = path.substr (next, path.size ()-next);
+  std::string item = path.substr (1, next - 1);
+  std::string pathLeft = path.substr (next, path.size () - next);
 
   //
-  // If root is zero, we're beginning to see if we can use the object name 
-  // service to resolve this path.  In this case, we must see the name space 
-  // "/Names" on the front of this path.  There is no object associated with 
-  // the root of the "/Names" namespace, so we just ignore it and move on to 
+  // If root is zero, we're beginning to see if we can use the object name
+  // service to resolve this path.  In this case, we must see the name space
+  // "/Names" on the front of this path.  There is no object associated with
+  // the root of the "/Names" namespace, so we just ignore it and move on to
   // the next segment.
   //
   if (root == 0)
@@ -468,49 +501,49 @@
     {
       // This is a call to GetObject
       std::string tidString = item.substr (1, item.size () - 1);
-      NS_LOG_DEBUG ("GetObject="<<tidString<<" on path="<<GetResolvedPath ());
+      NS_LOG_DEBUG ("GetObject=" << tidString << " on path=" << GetResolvedPath ());
       TypeId tid = TypeId::LookupByName (tidString);
       Ptr<Object> object = root->GetObject<Object> (tid);
       if (object == 0)
         {
-          NS_LOG_DEBUG ("GetObject ("<<tidString<<") failed on path="<<GetResolvedPath ());
+          NS_LOG_DEBUG ("GetObject (" << tidString << ") failed on path=" << GetResolvedPath ());
           return;
         }
       m_workStack.push_back (item);
       DoResolve (pathLeft, object);
       m_workStack.pop_back ();
     }
-  else 
+  else
     {
       // this is a normal attribute.
       TypeId tid;
       TypeId nextTid = root->GetInstanceTypeId ();
       bool foundMatch = false;
-      
+
       do
         {
           tid = nextTid;
-          
-          for (uint32_t i = 0; i < tid.GetAttributeN(); i++)
+
+          for (uint32_t i = 0; i < tid.GetAttributeN (); i++)
             {
               struct TypeId::AttributeInformation info;
-              info = tid.GetAttribute(i);
+              info = tid.GetAttribute (i);
               if (info.name != item && item != "*")
                 {
                   continue;
                 }
               // attempt to cast to a pointer checker.
-              const PointerChecker *pChecker = dynamic_cast<const PointerChecker *> (PeekPointer(info.checker));
+              const PointerChecker *pChecker = dynamic_cast<const PointerChecker *> (PeekPointer (info.checker));
               if (pChecker != 0)
                 {
-                  NS_LOG_DEBUG ("GetAttribute(ptr)="<<info.name<<" on path="<<GetResolvedPath ());
+                  NS_LOG_DEBUG ("GetAttribute(ptr)=" << info.name << " on path=" << GetResolvedPath ());
                   PointerValue pValue;
                   root->GetAttribute (info.name, pValue);
                   Ptr<Object> object = pValue.Get<Object> ();
                   if (object == 0)
                     {
-                      NS_LOG_ERROR ("Requested object name=\""<<item<<
-                                    "\" exists on path=\""<<GetResolvedPath ()<<"\""
+                      NS_LOG_ERROR ("Requested object name=\"" << item <<
+                                    "\" exists on path=\"" << GetResolvedPath () << "\""
                                     " but is null.");
                       continue;
                     }
@@ -520,11 +553,11 @@
                   m_workStack.pop_back ();
                 }
               // attempt to cast to an object vector.
-              const ObjectPtrContainerChecker *vectorChecker = 
+              const ObjectPtrContainerChecker *vectorChecker =
                 dynamic_cast<const ObjectPtrContainerChecker *> (PeekPointer (info.checker));
               if (vectorChecker != 0)
                 {
-                  NS_LOG_DEBUG ("GetAttribute(vector)="<<info.name<<" on path="<<GetResolvedPath () << pathLeft);
+                  NS_LOG_DEBUG ("GetAttribute(vector)=" << info.name << " on path=" << GetResolvedPath () << pathLeft);
                   foundMatch = true;
                   ObjectPtrContainerValue vector;
                   root->GetAttribute (info.name, vector);
@@ -537,20 +570,21 @@
             }
 
           nextTid = tid.GetParent ();
-        } while (nextTid != tid);
-      
+        }
+      while (nextTid != tid);
+
       if (!foundMatch)
         {
-          NS_LOG_DEBUG ("Requested item="<<item<<" does not exist on path="<<GetResolvedPath ());
+          NS_LOG_DEBUG ("Requested item=" << item << " does not exist on path=" << GetResolvedPath ());
           return;
         }
     }
 }
 
-void 
+void
 Resolver::DoArrayResolve (std::string path, const ObjectPtrContainerValue &container)
 {
-  NS_LOG_FUNCTION(this << path << &container);
+  NS_LOG_FUNCTION (this << path << &container);
   NS_ASSERT (path != "");
   NS_ASSERT ((path.find ("/")) == 0);
   std::string::size_type next = path.find ("/", 1);
@@ -558,8 +592,8 @@
     {
       return;
     }
-  std::string item = path.substr (1, next-1);
-  std::string pathLeft = path.substr (next, path.size ()-next);
+  std::string item = path.substr (1, next - 1);
+  std::string pathLeft = path.substr (next, path.size () - next);
 
   ArrayMatcher matcher = ArrayMatcher (item);
   ObjectPtrContainerValue::Iterator it;
@@ -583,12 +617,16 @@
 class ConfigImpl : public Singleton<ConfigImpl>
 {
 public:
+  // Keep Set and SetFailSafe since their errors are triggered
+  // by the underlying ObjecBase functions.
   /** \copydoc Config::Set() */
   void Set (std::string path, const AttributeValue &value);
-  /** \copydoc Config::ConnectWithoutContext() */
-  void ConnectWithoutContext (std::string path, const CallbackBase &cb);
-  /** \copydoc Config::Connect() */
-  void Connect (std::string path, const CallbackBase &cb);
+  /** \copydoc Config::SetFailSafe() */
+  bool SetFailSafe (std::string path, const AttributeValue &value);
+  /** \copydoc Config::ConnectWithoutContextFailSafe() */
+  bool ConnectWithoutContextFailSafe (std::string path, const CallbackBase &cb);
+  /** \copydoc Config::ConnectFailSafe() */
+  bool ConnectFailSafe (std::string path, const CallbackBase &cb);
   /** \copydoc Config::DisconnectWithoutContext() */
   void DisconnectWithoutContext (std::string path, const CallbackBase &cb);
   /** \copydoc Config::Disconnect() */
@@ -610,9 +648,9 @@
   /**
    * Break a Config path into the leading path and the last leaf token.
    * \param [in] path The Config path.
-   * \param [in,out] root The leading part of the \p path,
+   * \param [in,out] root The leading part of the \pname{path},
    *   up to the final slash.
-   * \param [in,out] leaf The trailing part of the \p path.
+   * \param [in,out] leaf The trailing part of the \pname{path}.
    */
   void ParsePath (std::string path, std::string *root, std::string *leaf) const;
 
@@ -624,7 +662,7 @@
 
 };  // class ConfigImpl
 
-void 
+void
 ConfigImpl::ParsePath (std::string path, std::string *root, std::string *leaf) const
 {
   NS_LOG_FUNCTION (this << path << root << leaf);
@@ -632,11 +670,11 @@
   std::string::size_type slash = path.find_last_of ("/");
   NS_ASSERT (slash != std::string::npos);
   *root = path.substr (0, slash);
-  *leaf = path.substr (slash+1, path.size ()-(slash+1));
+  *leaf = path.substr (slash + 1, path.size () - (slash + 1));
   NS_LOG_FUNCTION (path << *root << *leaf);
 }
 
-void 
+void
 ConfigImpl::Set (std::string path, const AttributeValue &value)
 {
   NS_LOG_FUNCTION (this << path << &value);
@@ -646,23 +684,26 @@
   MatchContainer container = LookupMatches (root);
   container.Set (leaf, value);
 }
-void 
-ConfigImpl::ConnectWithoutContext (std::string path, const CallbackBase &cb)
+bool
+ConfigImpl::SetFailSafe (std::string path, const AttributeValue &value)
+{
+  NS_LOG_FUNCTION (this << path << &value);
+
+  std::string root, leaf;
+  ParsePath (path, &root, &leaf);
+  MatchContainer container = LookupMatches (root);
+  return container.SetFailSafe (leaf, value);
+}
+bool
+ConfigImpl::ConnectWithoutContextFailSafe (std::string path, const CallbackBase &cb)
 {
   NS_LOG_FUNCTION (this << path << &cb);
   std::string root, leaf;
   ParsePath (path, &root, &leaf);
   MatchContainer container = LookupMatches (root);
-  if (container.GetN () == 0)
-    {
-      std::size_t lastFwdSlash = root.rfind ("/");
-      NS_LOG_WARN ("Failed to connect " << leaf
-                   << ", the Requested object name = " << root.substr (lastFwdSlash + 1)
-                   << " does not exits on path " << root.substr (0, lastFwdSlash));
-    }
-  container.ConnectWithoutContext (leaf, cb);
+  return container.ConnectWithoutContextFailSafe (leaf, cb);
 }
-void 
+void
 ConfigImpl::DisconnectWithoutContext (std::string path, const CallbackBase &cb)
 {
   NS_LOG_FUNCTION (this << path << &cb);
@@ -673,29 +714,22 @@
     {
       std::size_t lastFwdSlash = root.rfind ("/");
       NS_LOG_WARN ("Failed to disconnect " << leaf
-                   << ", the Requested object name = " << root.substr (lastFwdSlash + 1)
-                   << " does not exits on path " << root.substr (0, lastFwdSlash));
+                                           << ", the Requested object name = " << root.substr (lastFwdSlash + 1)
+                                           << " does not exits on path " << root.substr (0, lastFwdSlash));
     }
   container.DisconnectWithoutContext (leaf, cb);
 }
-void 
-ConfigImpl::Connect (std::string path, const CallbackBase &cb)
+bool
+ConfigImpl::ConnectFailSafe (std::string path, const CallbackBase &cb)
 {
   NS_LOG_FUNCTION (this << path << &cb);
 
   std::string root, leaf;
   ParsePath (path, &root, &leaf);
   MatchContainer container = LookupMatches (root);
-  if (container.GetN () == 0)
-    {
-      std::size_t lastFwdSlash = root.rfind ("/");
-      NS_LOG_WARN ("Failed to connect " << leaf
-                   << ", the Requested object name = " << root.substr (lastFwdSlash + 1)
-                   << " does not exits on path " << root.substr (0, lastFwdSlash));
-    }
-  container.Connect (leaf, cb);
+  return container.ConnectFailSafe (leaf, cb);
 }
-void 
+void
 ConfigImpl::Disconnect (std::string path, const CallbackBase &cb)
 {
   NS_LOG_FUNCTION (this << path << &cb);
@@ -707,22 +741,23 @@
     {
       std::size_t lastFwdSlash = root.rfind ("/");
       NS_LOG_WARN ("Failed to disconnect " << leaf
-                   << ", the Requested object name = " << root.substr (lastFwdSlash + 1)
-                   << " does not exits on path " << root.substr (0, lastFwdSlash));
+                                           << ", the Requested object name = " << root.substr (lastFwdSlash + 1)
+                                           << " does not exits on path " << root.substr (0, lastFwdSlash));
     }
   container.Disconnect (leaf, cb);
 }
 
-MatchContainer 
+MatchContainer
 ConfigImpl::LookupMatches (std::string path)
 {
   NS_LOG_FUNCTION (this << path);
-  class LookupMatchesResolver : public Resolver 
+  class LookupMatchesResolver : public Resolver
   {
-  public:
+public:
     LookupMatchesResolver (std::string path)
       : Resolver (path)
-    {}
+    {
+    }
     virtual void DoOne (Ptr<Object> object, std::string path)
     {
       m_objects.push_back (object);
@@ -746,14 +781,14 @@
   return MatchContainer (resolver.m_objects, resolver.m_contexts, path);
 }
 
-void 
+void
 ConfigImpl::RegisterRootNamespaceObject (Ptr<Object> obj)
 {
   NS_LOG_FUNCTION (this << obj);
   m_roots.push_back (obj);
 }
 
-void 
+void
 ConfigImpl::UnregisterRootNamespaceObject (Ptr<Object> obj)
 {
   NS_LOG_FUNCTION (this << obj);
@@ -774,7 +809,7 @@
   NS_LOG_FUNCTION (this);
   return m_roots.size ();
 }
-Ptr<Object> 
+Ptr<Object>
 ConfigImpl::GetRootNamespaceObject (std::size_t i) const
 {
   NS_LOG_FUNCTION (this << i);
@@ -801,16 +836,20 @@
       (*i)->ResetInitialValue ();
     }
 }
-
 void Set (std::string path, const AttributeValue &value)
 {
   NS_LOG_FUNCTION (path << &value);
   ConfigImpl::Get ()->Set (path, value);
 }
+bool SetFailSafe (std::string path, const AttributeValue &value)
+{
+  NS_LOG_FUNCTION (path << &value);
+  return ConfigImpl::Get ()->SetFailSafe (path, value);
+}
 void SetDefault (std::string name, const AttributeValue &value)
 {
   NS_LOG_FUNCTION (name << &value);
-  if (!SetDefaultFailSafe(name, value))
+  if (!SetDefaultFailSafe (name, value))
     {
       NS_FATAL_ERROR ("Could not set default value for " << name);
     }
@@ -824,7 +863,7 @@
       return false;
     }
   std::string tidName = fullName.substr (0, pos);
-  std::string paramName = fullName.substr (pos+2, fullName.size () - (pos+2));
+  std::string paramName = fullName.substr (pos + 2, fullName.size () - (pos + 2));
   TypeId tid;
   bool ok = TypeId::LookupByNameFailSafe (tidName, &tid);
   if (!ok)
@@ -833,7 +872,7 @@
     }
   for (uint32_t j = 0; j < tid.GetAttributeN (); j++)
     {
-      struct TypeId::AttributeInformation tmp = tid.GetAttribute(j);
+      struct TypeId::AttributeInformation tmp = tid.GetAttribute (j);
       if (tmp.name == paramName)
         {
           Ptr<AttributeValue> v = tmp.checker->CreateValidValue (value);
@@ -860,20 +899,34 @@
 void ConnectWithoutContext (std::string path, const CallbackBase &cb)
 {
   NS_LOG_FUNCTION (path << &cb);
-  ConfigImpl::Get ()->ConnectWithoutContext (path, cb);
+  ConnectWithoutContextFailSafe (path, cb);
+}
+bool ConnectWithoutContextFailSafe (std::string path, const CallbackBase &cb)
+{
+  NS_LOG_FUNCTION (path << &cb);
+  return ConfigImpl::Get ()->ConnectWithoutContextFailSafe (path, cb);
 }
 void DisconnectWithoutContext (std::string path, const CallbackBase &cb)
 {
   NS_LOG_FUNCTION (path << &cb);
   ConfigImpl::Get ()->DisconnectWithoutContext (path, cb);
 }
-void 
+void
 Connect (std::string path, const CallbackBase &cb)
 {
   NS_LOG_FUNCTION (path << &cb);
-  ConfigImpl::Get ()->Connect (path, cb);
+  if (!ConnectFailSafe (path, cb))
+    {
+      NS_FATAL_ERROR ("Could not connect callback to " << path);
+    }
 }
-void 
+bool
+ConnectFailSafe (std::string path, const CallbackBase &cb)
+{
+  NS_LOG_FUNCTION (path << &cb);
+  return ConfigImpl::Get ()->ConnectFailSafe (path, cb);
+}
+void
 Disconnect (std::string path, const CallbackBase &cb)
 {
   NS_LOG_FUNCTION (path << &cb);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/config.h ns-3.31/src/core/model/config.h
--- ns-3.30.1/src/core/model/config.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/config.h	2020-06-27 17:38:30.000000000 -0700
@@ -66,11 +66,16 @@
  */
 void Set (std::string path, const AttributeValue &value);
 /**
+ * \copydoc Set()
+ * \return \c true if any matching attributes could be set.
+ */
+bool SetFailSafe (std::string path, const AttributeValue &value);
+/**
  * \ingroup config
  * \param [in] name The full name of the attribute
  * \param [in] value The value to set.
  *
- * This method overrides the initial value of the 
+ * This method overrides the initial value of the
  * matching attribute. This method cannot fail: it will
  * crash if the input attribute name or value is invalid.
  */
@@ -81,8 +86,8 @@
  * \param [in] value The value to set.
  * \returns \c true if the value was set successfully, false otherwise.
  *
- * This method overrides the initial value of the 
- * matching attribute. 
+ * This method overrides the initial value of the
+ * matching attribute.
  */
 bool SetDefaultFailSafe (std::string name, const AttributeValue &value);
 /**
@@ -113,6 +118,11 @@
  */
 void ConnectWithoutContext (std::string path, const CallbackBase &cb);
 /**
+ * \copydoc ConnectWithoutContext()
+ * \returns \c true if any trace sources could be connected.
+ */
+bool ConnectWithoutContextFailSafe (std::string path, const CallbackBase &cb);
+/**
  * \ingroup config
  * \param [in] path A path to match trace sources.
  * \param [in] cb The callback to disconnect to the matching trace sources.
@@ -132,6 +142,11 @@
  */
 void Connect (std::string path, const CallbackBase &cb);
 /**
+ * \copydoc Connect()
+ * \returns \c true if any trace sources could be connected.
+ */
+bool ConnectFailSafe (std::string path, const CallbackBase &cb);
+/**
  * \ingroup config
  * \param [in] path A path to match trace sources.
  * \param [in] cb The callback to connect to the matching trace sources.
@@ -161,8 +176,8 @@
    * \param [in] contexts The corresponding contexts.
    * \param [in] path The path used for object matching.
    */
-  MatchContainer (const std::vector<Ptr<Object> > &objects, 
-                  const std::vector<std::string> &contexts, 
+  MatchContainer (const std::vector<Ptr<Object> > &objects,
+                  const std::vector<std::string> &contexts,
                   std::string path);
 
   /**
@@ -205,6 +220,11 @@
    */
   void Set (std::string name, const AttributeValue &value);
   /**
+   * \copydoc Set()
+   * \returns \c true if any attributes could be set.
+   */
+  bool SetFailSafe (std::string name, const AttributeValue &value);
+  /**
    * \param [in] name The name of the trace source to connect to
    * \param [in] cb The sink to connect to the trace source
    *
@@ -214,6 +234,11 @@
    */
   void Connect (std::string name, const CallbackBase &cb);
   /**
+   * \copydoc Connect()
+   * \returns \c true if any trace sources could be connected.
+   */
+  bool ConnectFailSafe (std::string name, const CallbackBase &cb);
+  /**
    * \param [in] name The name of the trace source to connect to
    * \param [in] cb The sink to connect to the trace source
    *
@@ -223,6 +248,11 @@
    */
   void ConnectWithoutContext (std::string name, const CallbackBase &cb);
   /**
+   * \copydoc ConnectWithoutContext()
+   * \returns \c true if any trace sources could be connected.
+   */
+  bool ConnectWithoutContextFailSafe (std::string name, const CallbackBase &cb);
+  /**
    * \param [in] name The name of the trace source to disconnect from
    * \param [in] cb The sink to disconnect from the trace source
    *
@@ -240,7 +270,7 @@
    * \sa ns3::Config::DisconnectWithoutContext
    */
   void DisconnectWithoutContext (std::string name, const CallbackBase &cb);
-  
+
 private:
   /** The list of objects in this container. */
   std::vector<Ptr<Object> > m_objects;
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/default-deleter.h ns-3.31/src/core/model/default-deleter.h
--- ns-3.30.1/src/core/model/default-deleter.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/default-deleter.h	2020-06-27 17:38:30.000000000 -0700
@@ -50,7 +50,8 @@
    * \tparam T \deduced The object type being deleted.
    * \param [in] object The object to delete.
    */
-  inline static void Delete (T *object) {
+  inline static void Delete (T *object)
+  {
     delete object;
   }
 };
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/default-simulator-impl.cc ns-3.31/src/core/model/default-simulator-impl.cc
--- ns-3.30.1/src/core/model/default-simulator-impl.cc	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/default-simulator-impl.cc	2020-06-27 17:38:30.000000000 -0700
@@ -73,7 +73,7 @@
   m_unscheduledEvents = 0;
   m_eventCount = 0;
   m_eventsWithContextEmpty = true;
-  m_main = SystemThread::Self();
+  m_main = SystemThread::Self ();
 }
 
 DefaultSimulatorImpl::~DefaultSimulatorImpl ()
@@ -99,7 +99,7 @@
 DefaultSimulatorImpl::Destroy ()
 {
   NS_LOG_FUNCTION (this);
-  while (!m_destroyEvents.empty ()) 
+  while (!m_destroyEvents.empty ())
     {
       Ptr<EventImpl> ev = m_destroyEvents.front ().PeekEventImpl ();
       m_destroyEvents.pop_front ();
@@ -129,7 +129,7 @@
 }
 
 // System ID for non-distributed simulation is always zero
-uint32_t 
+uint32_t
 DefaultSimulatorImpl::GetSystemId (void) const
 {
   return 0;
@@ -154,7 +154,7 @@
   ProcessEventsWithContext ();
 }
 
-bool 
+bool
 DefaultSimulatorImpl::IsFinished (void) const
 {
   return m_events->IsEmpty () || m_stop;
@@ -172,21 +172,21 @@
   EventsWithContext eventsWithContext;
   {
     CriticalSection cs (m_eventsWithContextMutex);
-    m_eventsWithContext.swap(eventsWithContext);
+    m_eventsWithContext.swap (eventsWithContext);
     m_eventsWithContextEmpty = true;
   }
   while (!eventsWithContext.empty ())
     {
-       EventWithContext event = eventsWithContext.front ();
-       eventsWithContext.pop_front ();
-       Scheduler::Event ev;
-       ev.impl = event.event;
-       ev.key.m_ts = m_currentTs + event.timestamp;
-       ev.key.m_context = event.context;
-       ev.key.m_uid = m_uid;
-       m_uid++;
-       m_unscheduledEvents++;
-       m_events->Insert (ev);
+      EventWithContext event = eventsWithContext.front ();
+      eventsWithContext.pop_front ();
+      Scheduler::Event ev;
+      ev.impl = event.event;
+      ev.key.m_ts = m_currentTs + event.timestamp;
+      ev.key.m_context = event.context;
+      ev.key.m_uid = m_uid;
+      m_uid++;
+      m_unscheduledEvents++;
+      m_events->Insert (ev);
     }
 }
 
@@ -195,11 +195,11 @@
 {
   NS_LOG_FUNCTION (this);
   // Set the current threadId as the main threadId
-  m_main = SystemThread::Self();
+  m_main = SystemThread::Self ();
   ProcessEventsWithContext ();
   m_stop = false;
 
-  while (!m_events->IsEmpty () && !m_stop) 
+  while (!m_events->IsEmpty () && !m_stop)
     {
       ProcessOneEvent ();
     }
@@ -209,14 +209,14 @@
   NS_ASSERT (!m_events->IsEmpty () || m_unscheduledEvents == 0);
 }
 
-void 
+void
 DefaultSimulatorImpl::Stop (void)
 {
   NS_LOG_FUNCTION (this);
   m_stop = true;
 }
 
-void 
+void
 DefaultSimulatorImpl::Stop (Time const &delay)
 {
   NS_LOG_FUNCTION (this << delay.GetTimeStep ());
@@ -272,7 +272,7 @@
       ev.event = event;
       {
         CriticalSection cs (m_eventsWithContextMutex);
-        m_eventsWithContext.push_back(ev);
+        m_eventsWithContext.push_back (ev);
         m_eventsWithContextEmpty = false;
       }
     }
@@ -312,7 +312,7 @@
   return TimeStep (m_currentTs);
 }
 
-Time 
+Time
 DefaultSimulatorImpl::GetDelayLeft (const EventId &id) const
 {
   if (IsExpired (id))
@@ -372,8 +372,8 @@
 {
   if (id.GetUid () == 2)
     {
-      if (id.PeekEventImpl () == 0 ||
-          id.PeekEventImpl ()->IsCancelled ())
+      if (id.PeekEventImpl () == 0
+          || id.PeekEventImpl ()->IsCancelled ())
         {
           return true;
         }
@@ -387,11 +387,10 @@
         }
       return true;
     }
-  if (id.PeekEventImpl () == 0 ||
-      id.GetTs () < m_currentTs ||
-      (id.GetTs () == m_currentTs &&
-       id.GetUid () <= m_currentUid) ||
-      id.PeekEventImpl ()->IsCancelled ()) 
+  if (id.PeekEventImpl () == 0
+      || id.GetTs () < m_currentTs
+      || (id.GetTs () == m_currentTs && id.GetUid () <= m_currentUid)
+      || id.PeekEventImpl ()->IsCancelled ())
     {
       return true;
     }
@@ -401,7 +400,7 @@
     }
 }
 
-Time 
+Time
 DefaultSimulatorImpl::GetMaximumSimulationTime (void) const
 {
   return TimeStep (0x7fffffffffffffffLL);
diff -Naur -x '*.dia' -x '*.pcap' ns-3.30.1/src/core/model/default-simulator-impl.h ns-3.31/src/core/model/default-simulator-impl.h
--- ns-3.30.1/src/core/model/default-simulator-impl.h	2019-08-12 16:30:34.000000000 -0700
+++ ns-3.31/src/core/model/default-simulator-impl.h	2020-06-27 17:38:30.000000000 -0700
@@ -86,9 +86,10 @@
   void ProcessOneEvent (void);
   /** Move events from a different context into the main event queue. */
   void ProcessEventsWithContext (void);
- 
+
   /** Wrap an event with its execution context. */
-  struct EventWithContext {
+  struct EventWithContext
+  {
     /** The event context. */
     uint32_t context;
     /** Event timestamp. */
